var gulp = require('gulp');
var uglifyjs = require('uglify-es');
var composer = require('gulp-uglify/composer');
var uglify = composer(uglifyjs, console);
var gutil = require('gulp-util');
var cssnano = require('gulp-cssnano');
var prefix = require('gulp-autoprefixer');
var runSequence = require('run-sequence');
var rename = require('gulp-rename');
var del = require('del');
var errHandler = function (e) {
    gutil.log(e.message);
    gutil.log(e);
    this.emit('end');    // Keep gulp from hanging on this task
};
gulp.task('build-js', () => {
    gutil.log('Building bundle');
    return gulp.src('./src/js/jquery.flagstrap.js').pipe(uglify()).on('error', errHandler).pipe(rename('flagstrap.min.js')).pipe(gulp.dest('./dist/js'));
});
gulp.task('build-css', () => {
    return gulp.src('./src/css/flags.css').pipe(prefix({ 'browsers': ['last 3 versions'] })).pipe(cssnano({ autoprefixer: false })).pipe(rename('flagstrap.min.css')).pipe(gulp.dest('./dist/css'));
});
gulp.task('image', () => {
    return gulp.src('./src/img/flags.png').pipe(gulp.dest('./dist/img'));
});
gulp.task('cleanbuild', () => {
    gutil.log('Preparing...');
    return del(['./dist']);
});
gulp.task('default', cb => {
    runSequence('cleanbuild', 'build-js', 'build-css', 'image', () => {
        gutil.log('Building Finished...');
    });
});